1#!/bin/sh
2#
3# git-submodules.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15OPTIONS_SPEC=
16. git-sh-setup
17. git-sh-i18n
18. git-parse-remote
19require_work_tree
20
21command=
22branch=
23force=
24reference=
25cached=
26recursive=
27init=
28files=
29nofetch=
30update=
31prefix=
32
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
39 url="$1"
40 remoteurl=${remoteurl%/}
41 sep=/
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
57 ;;
58 esac
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
67 echo "$remoteurl$sep${url%/}"
68}
69
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
94}
95
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
107 test -z "$name" &&
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
109 echo "$name"
110}
111
112#
113# Clone a submodule
114#
115# Prior to calling, cmd_update checks that a possibly existing
116# path is not a git repository.
117# Likewise, cmd_add checks that path does not exist at all,
118# since it is the location of a new submodule.
119#
120module_clone()
121{
122 path=$1
123 url=$2
124 reference="$3"
125 quiet=
126 if test -n "$GIT_QUIET"
127 then
128 quiet=-q
129 fi
130
131 if test -n "$reference"
132 then
133 git-clone $quiet "$reference" -n "$url" "$path"
134 else
135 git-clone $quiet -n "$url" "$path"
136 fi ||
137 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
138}
139
140#
141# Add a new submodule to the working tree, .gitmodules and the index
142#
143# $@ = repo path
144#
145# optional branch is stored in global branch variable
146#
147cmd_add()
148{
149 # parse $args after "submodule ... add".
150 while test $# -ne 0
151 do
152 case "$1" in
153 -b | --branch)
154 case "$2" in '') usage ;; esac
155 branch=$2
156 shift
157 ;;
158 -f | --force)
159 force=$1
160 ;;
161 -q|--quiet)
162 GIT_QUIET=1
163 ;;
164 --reference)
165 case "$2" in '') usage ;; esac
166 reference="--reference=$2"
167 shift
168 ;;
169 --reference=*)
170 reference="$1"
171 shift
172 ;;
173 --)
174 shift
175 break
176 ;;
177 -*)
178 usage
179 ;;
180 *)
181 break
182 ;;
183 esac
184 shift
185 done
186
187 repo=$1
188 path=$2
189
190 if test -z "$path"; then
191 path=$(echo "$repo" |
192 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
193 fi
194
195 if test -z "$repo" -o -z "$path"; then
196 usage
197 fi
198
199 # assure repo is absolute or relative to parent
200 case "$repo" in
201 ./*|../*)
202 # dereference source url relative to parent's url
203 realrepo=$(resolve_relative_url "$repo") || exit
204 ;;
205 *:*|/*)
206 # absolute url
207 realrepo=$repo
208 ;;
209 *)
210 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
211 ;;
212 esac
213
214 # normalize path:
215 # multiple //; leading ./; /./; /../; trailing /
216 path=$(printf '%s/\n' "$path" |
217 sed -e '
218 s|//*|/|g
219 s|^\(\./\)*||
220 s|/\./|/|g
221 :start
222 s|\([^/]*\)/\.\./||
223 tstart
224 s|/*$||
225 ')
226 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
227 die "$(eval_gettext "'\$path' already exists in the index")"
228
229 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
230 then
231 (
232 eval_gettext "The following path is ignored by one of your .gitignore files:
233\$path
234Use -f if you really want to add it." &&
235 echo
236 ) >&2
237 exit 1
238 fi
239
240 # perhaps the path exists and is already a git repo, else clone it
241 if test -e "$path"
242 then
243 if test -d "$path"/.git -o -f "$path"/.git
244 then
245 eval_gettext "Adding existing repo at '\$path' to the index"; echo
246 else
247 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
248 fi
249
250 else
251
252 module_clone "$path" "$realrepo" "$reference" || exit
253 (
254 clear_local_git_env
255 cd "$path" &&
256 # ash fails to wordsplit ${branch:+-b "$branch"...}
257 case "$branch" in
258 '') git checkout -f -q ;;
259 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
260 esac
261 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
262 fi
263 git config submodule."$path".url "$realrepo"
264
265 git add $force "$path" ||
266 die "$(eval_gettext "Failed to add submodule '\$path'")"
267
268 git config -f .gitmodules submodule."$path".path "$path" &&
269 git config -f .gitmodules submodule."$path".url "$repo" &&
270 git add --force .gitmodules ||
271 die "$(eval_gettext "Failed to register submodule '\$path'")"
272}
273
274#
275# Execute an arbitrary command sequence in each checked out
276# submodule
277#
278# $@ = command to execute
279#
280cmd_foreach()
281{
282 # parse $args after "submodule ... foreach".
283 while test $# -ne 0
284 do
285 case "$1" in
286 -q|--quiet)
287 GIT_QUIET=1
288 ;;
289 --recursive)
290 recursive=1
291 ;;
292 -*)
293 usage
294 ;;
295 *)
296 break
297 ;;
298 esac
299 shift
300 done
301
302 toplevel=$(pwd)
303
304 # dup stdin so that it can be restored when running the external
305 # command in the subshell (and a recursive call to this function)
306 exec 3<&0
307
308 module_list |
309 while read mode sha1 stage path
310 do
311 if test -e "$path"/.git
312 then
313 say "$(eval_gettext "Entering '\$prefix\$path'")"
314 name=$(module_name "$path")
315 (
316 prefix="$prefix$path/"
317 clear_local_git_env
318 cd "$path" &&
319 eval "$@" &&
320 if test -n "$recursive"
321 then
322 cmd_foreach "--recursive" "$@"
323 fi
324 ) <&3 3<&- ||
325 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
326 fi
327 done
328}
329
330#
331# Register submodules in .git/config
332#
333# $@ = requested paths (default to all)
334#
335cmd_init()
336{
337 # parse $args after "submodule ... init".
338 while test $# -ne 0
339 do
340 case "$1" in
341 -q|--quiet)
342 GIT_QUIET=1
343 ;;
344 --)
345 shift
346 break
347 ;;
348 -*)
349 usage
350 ;;
351 *)
352 break
353 ;;
354 esac
355 shift
356 done
357
358 module_list "$@" |
359 while read mode sha1 stage path
360 do
361 # Skip already registered paths
362 name=$(module_name "$path") || exit
363 if test -z "$(git config "submodule.$name.url")"
364 then
365 url=$(git config -f .gitmodules submodule."$name".url)
366 test -z "$url" &&
367 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
368
369 # Possibly a url relative to parent
370 case "$url" in
371 ./*|../*)
372 url=$(resolve_relative_url "$url") || exit
373 ;;
374 esac
375 git config submodule."$name".url "$url" ||
376 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
377 fi
378
379 # Copy "update" setting when it is not set yet
380 upd="$(git config -f .gitmodules submodule."$name".update)"
381 test -z "$upd" ||
382 test -n "$(git config submodule."$name".update)" ||
383 git config submodule."$name".update "$upd" ||
384 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
385
386 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
387 done
388}
389
390#
391# Update each submodule path to correct revision, using clone and checkout as needed
392#
393# $@ = requested paths (default to all)
394#
395cmd_update()
396{
397 # parse $args after "submodule ... update".
398 orig_flags=
399 while test $# -ne 0
400 do
401 case "$1" in
402 -q|--quiet)
403 GIT_QUIET=1
404 ;;
405 -i|--init)
406 init=1
407 ;;
408 -N|--no-fetch)
409 nofetch=1
410 ;;
411 -f|--force)
412 force=$1
413 ;;
414 -r|--rebase)
415 update="rebase"
416 ;;
417 --reference)
418 case "$2" in '') usage ;; esac
419 reference="--reference=$2"
420 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
421 shift
422 ;;
423 --reference=*)
424 reference="$1"
425 ;;
426 -m|--merge)
427 update="merge"
428 ;;
429 --recursive)
430 recursive=1
431 ;;
432 --checkout)
433 update="checkout"
434 ;;
435 --)
436 shift
437 break
438 ;;
439 -*)
440 usage
441 ;;
442 *)
443 break
444 ;;
445 esac
446 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
447 shift
448 done
449
450 if test -n "$init"
451 then
452 cmd_init "--" "$@" || return
453 fi
454
455 cloned_modules=
456 module_list "$@" | {
457 err=
458 while read mode sha1 stage path
459 do
460 if test "$stage" = U
461 then
462 echo >&2 "Skipping unmerged submodule $path"
463 continue
464 fi
465 name=$(module_name "$path") || exit
466 url=$(git config submodule."$name".url)
467 if ! test -z "$update"
468 then
469 update_module=$update
470 else
471 update_module=$(git config submodule."$name".update)
472 fi
473
474 if test "$update_module" = "none"
475 then
476 echo "Skipping submodule '$path'"
477 continue
478 fi
479
480 if test -z "$url"
481 then
482 # Only mention uninitialized submodules when its
483 # path have been specified
484 test "$#" != "0" &&
485 say "$(eval_gettext "Submodule path '\$path' not initialized
486Maybe you want to use 'update --init'?")"
487 continue
488 fi
489
490 if ! test -d "$path"/.git -o -f "$path"/.git
491 then
492 module_clone "$path" "$url" "$reference"|| exit
493 cloned_modules="$cloned_modules;$name"
494 subsha1=
495 else
496 subsha1=$(clear_local_git_env; cd "$path" &&
497 git rev-parse --verify HEAD) ||
498 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
499 fi
500
501 if test "$subsha1" != "$sha1"
502 then
503 subforce=$force
504 # If we don't already have a -f flag and the submodule has never been checked out
505 if test -z "$subsha1" -a -z "$force"
506 then
507 subforce="-f"
508 fi
509
510 if test -z "$nofetch"
511 then
512 # Run fetch only if $sha1 isn't present or it
513 # is not reachable from a ref.
514 (clear_local_git_env; cd "$path" &&
515 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
516 test -z "$rev") || git-fetch)) ||
517 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
518 fi
519
520 # Is this something we just cloned?
521 case ";$cloned_modules;" in
522 *";$name;"*)
523 # then there is no local change to integrate
524 update_module= ;;
525 esac
526
527 must_die_on_failure=
528 case "$update_module" in
529 rebase)
530 command="git rebase"
531 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
532 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
533 must_die_on_failure=yes
534 ;;
535 merge)
536 command="git merge"
537 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
538 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
539 must_die_on_failure=yes
540 ;;
541 *)
542 command="git checkout $subforce -q"
543 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
544 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
545 ;;
546 esac
547
548 if (clear_local_git_env; cd "$path" && $command "$sha1")
549 then
550 say "$say_msg"
551 elif test -n "$must_die_on_failure"
552 then
553 die_with_status 2 "$die_msg"
554 else
555 err="${err};$die_msg"
556 continue
557 fi
558 fi
559
560 if test -n "$recursive"
561 then
562 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
563 res=$?
564 if test $res -gt 0
565 then
566 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
567 if test $res -eq 1
568 then
569 err="${err};$die_msg"
570 continue
571 else
572 die_with_status $res "$die_msg"
573 fi
574 fi
575 fi
576 done
577
578 if test -n "$err"
579 then
580 OIFS=$IFS
581 IFS=';'
582 for e in $err
583 do
584 if test -n "$e"
585 then
586 echo >&2 "$e"
587 fi
588 done
589 IFS=$OIFS
590 exit 1
591 fi
592 }
593}
594
595set_name_rev () {
596 revname=$( (
597 clear_local_git_env
598 cd "$1" && {
599 git describe "$2" 2>/dev/null ||
600 git describe --tags "$2" 2>/dev/null ||
601 git describe --contains "$2" 2>/dev/null ||
602 git describe --all --always "$2"
603 }
604 ) )
605 test -z "$revname" || revname=" ($revname)"
606}
607#
608# Show commit summary for submodules in index or working tree
609#
610# If '--cached' is given, show summary between index and given commit,
611# or between working tree and given commit
612#
613# $@ = [commit (default 'HEAD'),] requested paths (default all)
614#
615cmd_summary() {
616 summary_limit=-1
617 for_status=
618 diff_cmd=diff-index
619
620 # parse $args after "submodule ... summary".
621 while test $# -ne 0
622 do
623 case "$1" in
624 --cached)
625 cached="$1"
626 ;;
627 --files)
628 files="$1"
629 ;;
630 --for-status)
631 for_status="$1"
632 ;;
633 -n|--summary-limit)
634 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
635 then
636 :
637 else
638 usage
639 fi
640 shift
641 ;;
642 --)
643 shift
644 break
645 ;;
646 -*)
647 usage
648 ;;
649 *)
650 break
651 ;;
652 esac
653 shift
654 done
655
656 test $summary_limit = 0 && return
657
658 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
659 then
660 head=$rev
661 test $# = 0 || shift
662 elif test -z "$1" -o "$1" = "HEAD"
663 then
664 # before the first commit: compare with an empty tree
665 head=$(git hash-object -w -t tree --stdin </dev/null)
666 test -z "$1" || shift
667 else
668 head="HEAD"
669 fi
670
671 if [ -n "$files" ]
672 then
673 test -n "$cached" &&
674 die "$(gettext -- "--cached cannot be used with --files")"
675 diff_cmd=diff-files
676 head=
677 fi
678
679 cd_to_toplevel
680 # Get modified modules cared by user
681 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
682 sane_egrep '^:([0-7]* )?160000' |
683 while read mod_src mod_dst sha1_src sha1_dst status name
684 do
685 # Always show modules deleted or type-changed (blob<->module)
686 test $status = D -o $status = T && echo "$name" && continue
687 # Also show added or modified modules which are checked out
688 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
689 echo "$name"
690 done
691 )
692
693 test -z "$modules" && return
694
695 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
696 sane_egrep '^:([0-7]* )?160000' |
697 cut -c2- |
698 while read mod_src mod_dst sha1_src sha1_dst status name
699 do
700 if test -z "$cached" &&
701 test $sha1_dst = 0000000000000000000000000000000000000000
702 then
703 case "$mod_dst" in
704 160000)
705 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
706 ;;
707 100644 | 100755 | 120000)
708 sha1_dst=$(git hash-object $name)
709 ;;
710 000000)
711 ;; # removed
712 *)
713 # unexpected type
714 (
715 eval_gettext "unexpected mode \$mod_dst" &&
716 echo
717 ) >&2
718 continue ;;
719 esac
720 fi
721 missing_src=
722 missing_dst=
723
724 test $mod_src = 160000 &&
725 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
726 missing_src=t
727
728 test $mod_dst = 160000 &&
729 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
730 missing_dst=t
731
732 total_commits=
733 case "$missing_src,$missing_dst" in
734 t,)
735 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
736 ;;
737 ,t)
738 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
739 ;;
740 t,t)
741 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
742 ;;
743 *)
744 errmsg=
745 total_commits=$(
746 if test $mod_src = 160000 -a $mod_dst = 160000
747 then
748 range="$sha1_src...$sha1_dst"
749 elif test $mod_src = 160000
750 then
751 range=$sha1_src
752 else
753 range=$sha1_dst
754 fi
755 GIT_DIR="$name/.git" \
756 git rev-list --first-parent $range -- | wc -l
757 )
758 total_commits=" ($(($total_commits + 0)))"
759 ;;
760 esac
761
762 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
763 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
764 if test $status = T
765 then
766 blob="$(gettext "blob")"
767 submodule="$(gettext "submodule")"
768 if test $mod_dst = 160000
769 then
770 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
771 else
772 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
773 fi
774 else
775 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
776 fi
777 if test -n "$errmsg"
778 then
779 # Don't give error msg for modification whose dst is not submodule
780 # i.e. deleted or changed to blob
781 test $mod_dst = 160000 && echo "$errmsg"
782 else
783 if test $mod_src = 160000 -a $mod_dst = 160000
784 then
785 limit=
786 test $summary_limit -gt 0 && limit="-$summary_limit"
787 GIT_DIR="$name/.git" \
788 git log $limit --pretty='format: %m %s' \
789 --first-parent $sha1_src...$sha1_dst
790 elif test $mod_dst = 160000
791 then
792 GIT_DIR="$name/.git" \
793 git log --pretty='format: > %s' -1 $sha1_dst
794 else
795 GIT_DIR="$name/.git" \
796 git log --pretty='format: < %s' -1 $sha1_src
797 fi
798 echo
799 fi
800 echo
801 done |
802 if test -n "$for_status"; then
803 if [ -n "$files" ]; then
804 gettext "# Submodules changed but not updated:"; echo
805 else
806 gettext "# Submodule changes to be committed:"; echo
807 fi
808 echo "#"
809 sed -e 's|^|# |' -e 's|^# $|#|'
810 else
811 cat
812 fi
813}
814#
815# List all submodules, prefixed with:
816# - submodule not initialized
817# + different revision checked out
818#
819# If --cached was specified the revision in the index will be printed
820# instead of the currently checked out revision.
821#
822# $@ = requested paths (default to all)
823#
824cmd_status()
825{
826 # parse $args after "submodule ... status".
827 orig_flags=
828 while test $# -ne 0
829 do
830 case "$1" in
831 -q|--quiet)
832 GIT_QUIET=1
833 ;;
834 --cached)
835 cached=1
836 ;;
837 --recursive)
838 recursive=1
839 ;;
840 --)
841 shift
842 break
843 ;;
844 -*)
845 usage
846 ;;
847 *)
848 break
849 ;;
850 esac
851 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
852 shift
853 done
854
855 module_list "$@" |
856 while read mode sha1 stage path
857 do
858 name=$(module_name "$path") || exit
859 url=$(git config submodule."$name".url)
860 displaypath="$prefix$path"
861 if test "$stage" = U
862 then
863 say "U$sha1 $displaypath"
864 continue
865 fi
866 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
867 then
868 say "-$sha1 $displaypath"
869 continue;
870 fi
871 set_name_rev "$path" "$sha1"
872 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
873 then
874 say " $sha1 $displaypath$revname"
875 else
876 if test -z "$cached"
877 then
878 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
879 set_name_rev "$path" "$sha1"
880 fi
881 say "+$sha1 $displaypath$revname"
882 fi
883
884 if test -n "$recursive"
885 then
886 (
887 prefix="$displaypath/"
888 clear_local_git_env
889 cd "$path" &&
890 eval cmd_status "$orig_args"
891 ) ||
892 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
893 fi
894 done
895}
896#
897# Sync remote urls for submodules
898# This makes the value for remote.$remote.url match the value
899# specified in .gitmodules.
900#
901cmd_sync()
902{
903 while test $# -ne 0
904 do
905 case "$1" in
906 -q|--quiet)
907 GIT_QUIET=1
908 shift
909 ;;
910 --)
911 shift
912 break
913 ;;
914 -*)
915 usage
916 ;;
917 *)
918 break
919 ;;
920 esac
921 done
922 cd_to_toplevel
923 module_list "$@" |
924 while read mode sha1 stage path
925 do
926 name=$(module_name "$path")
927 url=$(git config -f .gitmodules --get submodule."$name".url)
928
929 # Possibly a url relative to parent
930 case "$url" in
931 ./*|../*)
932 url=$(resolve_relative_url "$url") || exit
933 ;;
934 esac
935
936 if git config "submodule.$name.url" >/dev/null 2>/dev/null
937 then
938 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
939 git config submodule."$name".url "$url"
940
941 if test -e "$path"/.git
942 then
943 (
944 clear_local_git_env
945 cd "$path"
946 remote=$(get_default_remote)
947 git config remote."$remote".url "$url"
948 )
949 fi
950 fi
951 done
952}
953
954# This loop parses the command line arguments to find the
955# subcommand name to dispatch. Parsing of the subcommand specific
956# options are primarily done by the subcommand implementations.
957# Subcommand specific options such as --branch and --cached are
958# parsed here as well, for backward compatibility.
959
960while test $# != 0 && test -z "$command"
961do
962 case "$1" in
963 add | foreach | init | update | status | summary | sync)
964 command=$1
965 ;;
966 -q|--quiet)
967 GIT_QUIET=1
968 ;;
969 -b|--branch)
970 case "$2" in
971 '')
972 usage
973 ;;
974 esac
975 branch="$2"; shift
976 ;;
977 --cached)
978 cached="$1"
979 ;;
980 --)
981 break
982 ;;
983 -*)
984 usage
985 ;;
986 *)
987 break
988 ;;
989 esac
990 shift
991done
992
993# No command word defaults to "status"
994test -n "$command" || command=status
995
996# "-b branch" is accepted only by "add"
997if test -n "$branch" && test "$command" != add
998then
999 usage
1000fi
1001
1002# "--cached" is accepted only by "status" and "summary"
1003if test -n "$cached" && test "$command" != status -a "$command" != summary
1004then
1005 usage
1006fi
1007
1008"cmd_$command" "$@"